<template>
  <dibs-layout
    ref="layout"
    layout="two-columns"
    :alternate="true"
    :page="'synthesis'"
    class="dibs-synthesis"
  >
    <template #aside-header>
      <div class="dibs-synthesis--aside--header">
        <h1>{{ $t('page.synthesis.title') }}</h1>
        <div class="dibs-synthesis--aside--header--actions">
          <dibs-input-help @click="goToPrint"
            ><dibs-picto-export
          /></dibs-input-help>
          <!-- <dibs-input-help :disabled="true"><dibs-picto-dl /></dibs-input-help> -->
        </div>
      </div>
    </template>
    <template #aside-content>
      <div v-if="me" class="dibs-synthesis--aside--content">
        <dl class="dibs-synthesis--aside--data">
          <!--  <template v-if="me.email">
            <dt>Email</dt>
            <dd>{{ me.email }}</dd>
          </template> -->
          <dt>{{ $t('page.avs.form.labels.birthdate') }}</dt>
          <dd>
            {{ avsInfo.birthDateString }}
          </dd>
          <dt>{{ $t('page.avs.form.labels.age') }}</dt>
          <dd>
            {{ $tc('commons.years_old', age(avsInfo.birthDate)) }}
          </dd>
          <dt>{{ $t('page.avs.form.labels.avs_neutral') }}</dt>
          <dd>{{ avsInfo.navsString }}</dd>
          <template v-for="relation in relationships">
            <template v-if="relation.type == 'SPOUSE'">
              <dt :key="relation.type + '-dt0'">
                {{ $t('page.avs.form.labels.status') }}
              </dt>
              <dd :key="relation.type + '-dd0'">
                {{ $t('commons.status.married.neutral') }}
              </dd>
              <dt :key="relation.type + '-dt1'">
                {{ $t('page.avs.form.labels.relationship_start') }}
              </dt>
              <dd :key="relation.type + '-dd1'">
                {{ relation.startString }}
              </dd>
              <dt :key="relation.type + '-dt2'">
                {{ $t('page.avs.form.labels.partner_birth') }}
              </dt>
              <dd :key="relation.type + '-dd2'">
                {{ relation.person.birthDateString }}
              </dd>
              <dt :key="relation.type + '-dt3'">
                {{ $t('page.avs.form.labels.partner_age') }}
              </dt>
              <dd :key="relation.type + '-dd3'">
                {{ $tc('commons.years_old', age(relation.person.birthDate)) }}
              </dd>
            </template>
          </template>
          <template v-for="(child, id) in children">
            <dt :key="'child-' + id + '-dt'">
              {{ $t('page.avs.form.labels.child') }}&nbsp;{{ id + 1 }} /
              {{ $t('page.avs.form.labels.birthdate') }}
            </dt>
            <dd :key="'child-' + id + '-dd'">{{ child.birthDateString }}</dd>
          </template>
        </dl>
        <div class="dibs-synthesis--aside--footer">
          <dibs-input-help @click="$router.push(localePath('/avs'))">
            {{ $t('page.synthesis.actions.modify_personal_data') }}
          </dibs-input-help>
        </div>
        <hr class="dibs-synthesis--hr" />
        <div class="dibs-synthesis--aside--footer">
          <dibs-utils-push-up size="medium" />
          <dibs-elem-btn
            padding="small"
            :label="$t('page.synthesis.actions.simulate_data_changes')"
            @click="$refs['modal-simulation'].open()"
          />
        </div>
        <p style="text-align: justify">
          {{ $t('page.synthesis.warning') }}
        </p>
        <dibs-modal ref="modal-simulation">
          <template #title>{{
            $t('page.synthesis.modals.simulate.title')
          }}</template>
          <template #content>
            <div style="max-width: 23em">
              {{ $t('page.synthesis.modals.simulate.intro') }}
            </div>
            <br />
            <dibs-form-elem
              :label="$t('page.synthesis.modals.simulate.form.salary')"
              name="simulsalary"
            >
              <dibs-form-row :element-count="1">
                <dibs-input-money
                  id="simulsalary"
                  v-model="simulForm.declaredSalary"
                  :default="simulForm.declaredSalary"
                />
              </dibs-form-row>
            </dibs-form-elem>
            <dibs-form-elem
              :label="$t('page.synthesis.modals.simulate.form.rate')"
              name="simulrate"
            >
              <dibs-form-row :element-count="1">
                <dibs-input-percentage
                  id="simulrate"
                  v-model="simulForm.employmentLevel"
                  :default="simulForm.employmentLevel"
                />
              </dibs-form-row>
            </dibs-form-elem>
            <dibs-form-elem
              :label="$t('page.synthesis.modals.simulate.form.date')"
              name="simulpaydate"
            >
              <dibs-form-row :element-count="1">
                <dibs-input-date
                  id="simulpaydate"
                  v-model="simulForm.effectiveDate"
                  :default="simulForm.effectiveDate"
                />
              </dibs-form-row>
            </dibs-form-elem>
            <!-- eslint-disable vue/no-v-html -->
            <div
              style="max-width: 23em"
              v-html="$t('page.synthesis.modals.simulate.form.outro')"
            ></div>
            <!-- eslint-enable vue/no-v-html -->
            <dibs-elem-btn
              :label="$t('page.synthesis.modals.simulate.form.action')"
              picto="forward"
              :disabled="!simulformIsOk"
              @click="onSimulSave"
            />
          </template>
        </dibs-modal>
      </div>
    </template>
    <template #content>
      <div v-if="totalDigest.data.length" class="dibs-synthesis--content">
        <dibs-input-close
          v-if="totalDigest.data2"
          class="dibs-synthesis--reset"
          @click="onSimuReset"
        />
        <dibs-input-help
          v-if="totalDigest.data2"
          class="dibs-synthesis--settings"
          :no-border="true"
          :is-round="true"
          @click="$refs['modal-simulation'].open()"
        >
          <dibs-picto-settings :is-round="true" />
        </dibs-input-help>

        <pre v-if="mode == 'debug'">{{ { me, pvDigest } }}</pre>

        <dibs-partials-synthesis-block
          v-if="totalDigest.data.length"
          :strong="true"
          :title="$t('page.synthesis.parts.total.title')"
          :info="$t('page.synthesis.without_change')"
          :hide-info="!totalDigest.data2"
          :info2="totalDigest.data2 ? $t('page.synthesis.with_change') : null"
          :data="totalDigest.data"
          :data2="totalDigest.data2"
          @help="$refs['modal-total-info'].open()"
        />

        <dibs-partials-synthesis-block
          v-if="avsDigest.data.length"
          :title="$t('page.synthesis.parts.lavs.title')"
          :hide-info="true"
          :info="$t('page.synthesis.without_change')"
          :info2="totalDigest.data2 ? $t('page.synthesis.with_change') : null"
          :data="avsDigest.data"
          :data2="avsDigest.data2"
          @help="$refs['modal-avs-info'].open()"
        />
        <dibs-partials-synthesis-block
          :title="$t('page.synthesis.parts.lpp.title')"
          :hide-info="true"
          :delete-line="lppDigest.data && lppDigest.data.length > 0"
          :info="$t('page.synthesis.without_change')"
          :info2="totalDigest.data2 ? $t('page.synthesis.with_change') : null"
          :data="
            lppDigest.data && lppDigest.data.length
              ? lppDigest.data
              : [
                  {
                    label: $t('page.synthesis.parts.lpp.action_label'),
                  },
                ]
          "
          :data2="lppDigest.data2"
          :action="
            lppDigest.data && lppDigest.data.length
              ? null
              : $t('page.synthesis.parts.lpp.action')
          "
          @delete="deleteFund($event)"
          @help="$refs['modal-lpp-info'].open()"
          @action="$router.push(localePath('/lpp'))"
        />
        <dibs-partials-synthesis-block
          :title="$t('page.synthesis.parts.3a.title')"
          :hide-info="true"
          :info="$t('page.synthesis.without_change')"
          :info2="totalDigest.data2 ? $t('page.synthesis.with_change') : null"
          :delete-line="pvDigest.data.length > 0"
          :data="
            pvDigest.data.length
              ? pvDigest.data
              : [
                  {
                    label: $t('page.synthesis.parts.3a.action_label'),
                  },
                ]
          "
          :data2="pvDigest.data2"
          :summary2="pvDigest.summary2"
          :summary="
            pvDigest.summary && pvDigest.summary.label ? pvDigest.summary : null
          "
          :action="
            pvDigest.data.length ? null : $t('page.synthesis.parts.3a.action')
          "
          @delete="reset3A"
          @help="$refs['modal-3a-info'].open()"
          @action="$router.push(localePath('/3a'))"
        />
      </div>
      <dibs-modal ref="modal-total-info">
        <template #title>{{
          $t('page.synthesis.modals.total.title')
        }}</template>
        <template #content>
          <!-- eslint-disable-next-line vue/no-v-html -->
          <p v-html="$t('page.synthesis.modals.total.content')" />
        </template>
      </dibs-modal>
      <dibs-modal ref="modal-avs-info">
        <template #title>{{ $t('page.synthesis.modals.avs.title') }}</template>
        <template #content>
          <!-- eslint-disable-next-line vue/no-v-html -->
          <p v-html="$t('page.synthesis.modals.avs.content')" />
        </template>
      </dibs-modal>
      <dibs-modal ref="modal-lpp-info">
        <template #title>{{ $t('page.synthesis.modals.lpp.title') }}</template>
        <template #content>
          <!-- eslint-disable-next-line vue/no-v-html -->
          <p v-html="$t('page.synthesis.modals.lpp.content')" />
        </template>
      </dibs-modal>
      <dibs-modal ref="modal-3a-info">
        <template #title>{{ $t('page.synthesis.modals.3a.title') }}</template>
        <template #content>
          <!-- eslint-disable-next-line vue/no-v-html -->
          <p v-html="$t('page.synthesis.modals.3a.content')" />
        </template>
      </dibs-modal>
    </template>
  </dibs-layout>
</template>
<script>
import LZString from 'lz-string'
import { VueMaskFilter } from 'v-mask'
import _ from 'lodash'

export default {
  name: 'IndexPage',
  filters: { mask: VueMaskFilter },
  layout: 'dibs',
  data() {
    return {
      mode: this.$route.query.mode,
      me: null,
      avsInfo: null,
      relationshipType: null,
      relationships: [],
      children: [],
      totalDigest: { data: [], data2: null },
      avsDigest: { data: [], data2: null },
      lppDigest: { data: [], data2: null },
      pvDigest: {
        data: [],
        data2: null,
        summary: null,
      },
      policies: null,
      simulForm: {
        with: false,
        employmentLevel: 100,
        effectiveDate: null,
        declaredSalary: null,
      },
    }
  },
  computed: {
    simulformIsOk() {
      if (
        !this.simulForm.declaredSalary ||
        !this.simulForm.employmentLevel ||
        !this.simulForm.effectiveDate
      ) {
        return false
      }
      return true
    },
  },
  mounted() {
    this.$models.Loader().on()
    this.$models.User().checkConnectionStatus()
    this.init()
  },
  methods: {
    async init() {
      try {
        await this.$models.OpenPK().getPolicy()
      } catch (e) {
        await this.$models.OpenPK().reset()
      }

      try {
        const simulFormBak = this.simulForm
        let simulPromise = null
        if (simulFormBak.with) {
          simulFormBak.effectiveDate = this._uiDateToApi(
            simulFormBak.effectiveDate
          )
          simulPromise = await this.$models.Synthesis().get(simulFormBak)
        }
        Object.assign(this.$data, this.$options.data.apply(this))
        const values = []
        values.push(await this.$models.OpenAK().getInfo())
        values.push(await this.$models.User().getMe())
        values.push(await this.$models.OpenPV().get())
        values.push(await this.$models.OpenPK().getPolicy())
        values.push(await this.$models.Synthesis().get())
        values.push(simulFormBak)
        values.push(simulPromise)
        this._populateUI(...values)
        this.$models.Loader().off()
      } catch (e) {
        this.$router.push('/router')
      }
    },
    async _populateUI(
      avs,
      me,
      openPV,
      policies,
      digest,
      simulFormBak,
      simulDigest
    ) {
      if (!avs.navs) {
        this.$router.push(this.localePath('/router'))
      }
      this.avsInfo = this._manageAvsInfo(avs)
      this.totalDigest = this._extractTotalDigest(digest, simulDigest)
      this.avsDigest = this._extractAvsDigest(digest, simulDigest)
      this.lppDigest = await this._extractLppDigest(digest, simulDigest)
      this.pvDigest = this._extractPvDigest(digest, simulDigest)
      this.policies = this._extractPolicies(policies)
      if (simulFormBak.with) {
        this.simulForm = simulFormBak
        this.simulForm.effectiveDate = this._apiDateToUi(
          this.simulForm.effectiveDate
        )
      } else {
        this.simulForm = Object.assign(this.simulForm, this.policies)
        if (openPV.paydate) {
          this.simulForm.effectiveDate = this._apiDateToUi(openPV.paydate)
        }
      }

      this.me = me
    },
    _extractPolicies(policies) {
      if (!policies) {
        return null
      }

      const policy = policies[Object.keys(policies)[0]]

      if (!policy || !policy.salaryData) {
        return null
      }

      const policyData = {
        employmentLevel: policy.salaryData.employmentLevel,
        declaredSalary: policy.salaryData.declaredSalary,
      }

      return policyData
    },
    _extractPvDigest(digest, simul = null) {
      const extract = { data: [], summary: null }

      if (!digest['3a']) {
        return extract
      }

      const digest3A = digest['3a']
      const paydate = digest3A.paydate
        ? this._apiDateToUi(digest3A.paydate)
        : null
      const value = {
        label: this.$t('page.synthesis.parts.3a.capital_label'),
        value: digest3A.solde,
        isSmall: true,
      }

      // si il y a une rente mensuelle
      if (digest3A.monthly) {
        value.label2 =
          this.$t('page.synthesis.parts.3a.capital_until') + ' ' + paydate
        value.value2 = digest3A.monthly
      }

      extract.data.push(value)

      extract.summary = {
        label: this.$t('page.synthesis.parts.3a.capital_projection_label'),
        value: digest3A.term,
      }

      let simulData = {
        data: null,
        summary: null,
      }
      if (simul) {
        simulData = this._extractPvDigest(simul)
      }

      return {
        data: extract.data,
        summary: extract.summary,
        data2: simulData.data,
        summary2: simulData.summary,
      }
    },
    async _extractLppDigest(digest, simul = null) {
      const extract = []
      if (
        !digest.lpp_pensions_by_age ||
        digest.lpp_pensions_by_age.length < 1
      ) {
        return extract
      }

      const registry = await this.$models.OpenPK().getRegistry()
      const annuities = digest.lpp_pensions_by_age

      _.forEach(annuities, (annuity, id) => {
        extract.push({
          label:
            registry[id].name +
            ' - ' +
            this.$t('page.synthesis.parts.lpp.annuity_label'),
          // hint: 'à partir de ' + annuity.age + ' ans',
          hint: this.$t('commons.from_age') + this.$tc('commons.years_old', 65),
          value: annuity.annuities,
          fundId: id,
        })
      })

      let simulData = null
      if (simul) {
        simulData = await this._extractLppDigest(simul)
        simulData = simulData.data
      }

      return { data: extract, data2: simulData }
    },
    _extractAvsDigest(digest, simul = null) {
      const extract = []
      const periods = digest.avs_pensions_by_period
      _.forEach(periods, (pensions) => {
        pensions = this._unfilterArrayOrObject(pensions)

        let periodHint = this.$t('commons.from_date') + pensions.startString
        if (pensions.endString) {
          periodHint =
            this.$t('page.synthesis.parts.lavs.from') +
            ' ' +
            pensions.startString +
            ' ' +
            this.$t('page.synthesis.parts.lavs.to') +
            ' ' +
            pensions.endString
        }

        _.forEach(pensions.pensions, (pension) => {
          let period = {}
          if (pension.is_me) {
            period = {
              hint: periodHint,
              label: this.$t('page.synthesis.parts.lavs.annuity_avs_label'),
              value: pension.amount,
            }
          } else {
            period.label =
              this.$t('page.synthesis.parts.lavs.partner_annuity_from') +
              ' ' +
              pensions.startString
          }
          extract.push(period)
        })
      })

      let simulData = null
      if (simul) {
        simulData = this._extractAvsDigest(simul).data
      }

      return { data: extract, data2: simulData }
    },
    _extractTotalDigest(digest, simul = null) {
      const extract = []
      if (digest.annuities) {
        extract.push({
          label: this.$t('page.synthesis.parts.total.annuity_label'),
          value: digest.annuities,
        })
      }
      if (digest.capital) {
        extract.push({
          label: this.$t('page.synthesis.parts.total.capital_label'),
          value: digest.capital,
        })
      }

      let simulData = null
      if (simul) {
        simulData = this._extractTotalDigest(simul).data
      }

      return { data: extract, data2: simulData }
    },
    _manageAvsInfo(avs) {
      avs = this._unfilterArrayOrObject(Object.assign({}, avs))
      avs.navsString = VueMaskFilter(avs.navs, '###.####.####.##')

      const children = []
      _.forEach(avs.relationships, (relation) => {
        if (relation.type === 'CHILDREN') {
          children.push(relation)
        } else {
          relation = this._unfilterArrayOrObject(relation)
          relation.person = this._unfilterArrayOrObject(relation.person)
          this.relationships.push(relation)
        }
      })

      _.forEach(children, (child, id) => {
        this.children[id] = this._unfilterArrayOrObject(child.person)
        this.children[id].isAlive = !this.children[id].deathDate
      })

      delete avs.relationships

      return avs
    },
    _unfilterArrayOrObject(untransformed) {
      const transformed = Object.assign({}, untransformed)

      _.forEach(
        _.pick(transformed, ['start', 'end', 'birthDate', 'deathDate']),
        (date, id) => {
          if (date) {
            transformed[id + 'String'] = this._apiDateToUi(date)
          }
        }
      )

      return transformed
    },
    _apiDateToUi(date) {
      return date.split('-').reverse().join('.')
    },
    _uiDateToApi(date) {
      return date.split('.').reverse().join('-')
    },
    reset3A() {
      this.$models.Loader().on()
      this.$models
        .OpenPV()
        .reset()
        .finally(() => {
          this.init()
        })
        .catch(() => {
          this.$models.Loader().off()
          this.$refs.layout.loadMe(true)
        })
    },
    deleteFund(info) {
      this.$models.Loader().on()
      this.$models
        .OpenPK()
        .deleteFund(info.fundId)
        .catch(() => {
          this.$models.Loader().off()
          this.$refs.layout.loadMe(true)
        })
        .finally(() => {
          this.init()
        })
    },
    onSimulSave() {
      this.$models.Loader().on()
      this.simulForm.with = true
      this.$refs['modal-simulation'].close()
      this.init()
    },
    onSimuReset() {
      this.$models.Loader().on()
      this.simulForm.with = false
      this.init()
    },
    goToPrint() {
      // Sérialiser les données en JSON
      const jsonString = JSON.stringify(this.$data)

      // Compress the input string using LZString
      const compressedString =
        LZString.compressToEncodedURIComponent(jsonString)

      const route = this.$router.resolve(
        this.localePath({
          path: '/export',
          hash: compressedString,
        })
      )
      window.open(route.href)
    },
    age(date) {
      const dob = new Date(date)

      // calculate month difference from current date in time
      const monthDiff = Date.now() - dob.getTime()

      // convert the calculated difference in date format
      const ageDt = new Date(monthDiff)

      // extract year from date
      const year = ageDt.getUTCFullYear()

      // now calculate the age of the user
      const age = Math.abs(year - 1970)

      return age
    },
  },
}
</script>
